// Copyright (C) 2018-2024, Tellusim Technologies Inc. All rights reserved
// https://tellusim.com/

package com.tellusim;
import com.tellusim.*;
import java.lang.ref.Cleaner;

/*
 */
public class Size {
	
	public Size() { this(new_()); }
	public Size(Size s) { this(copy_(s.self)); }
	
	private static native long new_();
	private static native long copy_(long self);
	private static native void delete_(long self);
	private static native void set_width(long self, int width);
	private static native void set_height(long self, int height);
	private static native void set_depth(long self, int depth);
	private static native int get_width(long self);
	private static native int get_height(long self);
	private static native int get_depth(long self);
	
	protected Size(long self) {
		cleaner.register(this, new Destructor(self));
		this.self = self;
	}
	private static class Destructor implements Runnable {
		Destructor(long self) { this.self = self; }
		public void run() { delete_(self); }
		private long self;
	}
	
	private static Cleaner cleaner = Cleaner.create();
	
	protected long self;
}
