// Copyright (C) 2018-2024, Tellusim Technologies Inc. All rights reserved
// https://tellusim.com/

package com.tellusim;
import com.tellusim.*;
import java.lang.ref.Cleaner;

/*
 */
public class Tensor {
	
	public Tensor() { this(new_()); }
	public Tensor(Tensor t) { this(copy_(t.self)); }
	
	private static native long new_();
	private static native long copy_(long self);
	private static native void delete_(long self);
	
	protected Tensor(long self) {
		cleaner.register(this, new Destructor(self));
		this.self = self;
	}
	private static class Destructor implements Runnable {
		Destructor(long self) { this.self = self; }
		public void run() { delete_(self); }
		private long self;
	}
	
	private static Cleaner cleaner = Cleaner.create();
	
	protected long self;
}
